
package xelfi.browser.document;

import java.util.StringTokenizer;

import xelfi.editor.SourceFinder;
import xelfi.editor.XelfiFile;
import java.util.Vector;
import java.util.Enumeration;
import java.io.File;
import java.io.IOException;

// musi byt public kvuli getPreferredPath ...
public class XFile extends XelfiFile implements SourceFinder
{
    // SCANOVANI CLASSPATH
    static protected String[]       classPath = setPaths();
    static protected Vector         paths;
    static protected Vector         clsPaths;
    static protected Vector         clsPaths1;
    static protected int            pathCount;
    static private int              preferredPath = 0;
    static private boolean          dot = false;
    // In this static code it scans the CLASSPATH
    static String[] setPaths()
    {
        //System.out.println("setPaths");

        StringTokenizer t = new StringTokenizer(
            System.getProperty("java.class.path"),
            System.getProperty("path.separator"));

        int i,k = t.countTokens();
        classPath = new String[k];
        String s;
        for(i=0;i<k;i++)
        {
            classPath[i] = t.nextToken().trim();
            if( classPath[i].equals(".") )
            {// najdu-li .
                classPath[i] = (s = (new File(".")).getAbsolutePath().
                    trim()).substring(0,s.length()-1);
                dot = true;
            }
        }

        //do paths dam vsechny cesty (bez souboru .zip)
        paths = new Vector(k,10);
        for(i=0;i<k;i++)
        {
            if( (new File(classPath[i])).isDirectory() )
            {
                //vse ma koncit separatorem
                if( !classPath[i].endsWith(File.separator) )
                    classPath[i] = classPath[i].concat(File.separator);
                addPath(classPath[i]);
            }
        }
        pathCount = paths.size();

        clsPaths = new Vector(pathCount,10);
        for(i=0;i<pathCount;i++)
            clsPaths.addElement(paths.elementAt(i));

        if( dot )
        {
            clsPaths1 = new Vector(pathCount + 1,10);
            for(i=0;i<pathCount;i++)
            {
                clsPaths1.addElement(paths.elementAt(i));
            }
            clsPaths1.addElement("." + File.separator);
        }

        //System.out.println("setPaths end");

        return classPath;
    }




    // IMPLEMENTACE SOURCE FINDERU
    public XelfiFile findSource (String className, boolean create)
        throws IOException
    {
        return createXFile(className,create);
    }

    /** Tries to find class name for specified file.
    * This is the reverse process to the
    * findSource funciton.
    * @param f the file
    * @return xelfi file
    * @exception IOException if the file is not valid source file
    */
    public XelfiFile findClass (File f) throws IOException {
    String fs = f.getAbsolutePath ();
    int lst = fs.lastIndexOf ('.');
    if (f.exists () && lst > 0 && fs.substring (lst).equals (".java"))
    {
      fs = fs.substring (0, lst);
      String path = System.getProperty ("java.class.path");

      String last = null;
      StringTokenizer tok = new StringTokenizer (path, File.pathSeparator);
      try {
        for (;;) {
          File p = new File (tok.nextToken ());
          String ps = p.getAbsolutePath ();
          if (fs.indexOf (ps) == 0) {
            // the file is in this part of class path
            int psl = ps.length ();
            String rest = fs.substring (ps.charAt (psl - 1) == File.separatorChar ? psl + 1 : psl);
            int restl = rest.lastIndexOf (File.separatorChar);
            String kus = restl > 0 ? rest.substring (1, restl) : "";
    //            xf.packagee = kus.replace (file, '.');
    //            xf.name = rest.substring (restl + 1);
    //            xf.path = new File (p + kus);
            return new XFile (p + kus, kus.replace (File.separatorChar, '.')
                + rest.substring (restl + 1));
          }
        }
      } catch (java.util.NoSuchElementException ex) {
      }
    }
    // file has not been found
    throw new IOException ("File " + f + " is not valid source file");
    }
    //Hleda file z className
    static XFile createXFile(String className,
        boolean create) throws IOException
    {
        //System.out.println("createFile");
        String file = className.replace('.',File.separatorChar) +
            ".java";
        int i,k = paths.size();
        File f;
        String s;
        for(i=0;i<k;i++)
        {
            f = new File((s = (String)paths.elementAt(i)) + file);
            if( f.isFile() )
            {
            //System.out.println("createFile ddd");
                return new XFile(s,className);
            }
        }
        if( !create )
            throw new IOException();

        //System.out.println("createFile ddd");
        return new XFile((String)paths.elementAt(preferredPath),
                        className);
    }



    // PRACE S CESTAMI
    public static String[] getClassPath()
    { // vraci cely ClassPath, vcetne C:\java\cls\class.zip
        return classPath;
    }
    public static Enumeration  getClassPathsDir()
    { // vraci dir z ClassPath
        return clsPaths.elements();
    }
    public static Enumeration  getAllClassPathsDir()
    { // vraci dir z ClassPath
        if( dot ) return clsPaths1.elements();
        else return clsPaths.elements();
    }
    public static Enumeration getAllPaths()
    { // vraci dir z ClassPath + uzivatelske cesty
        return paths.elements();
    }
    // zkontroluje jestli tam uz neni jestli
    // nezacina stejne jako neco co uz tam je
    // a prida to do paths
    public static boolean addPath(String p)
    {
        if( !(new File(p)).isDirectory() )
            return false;

        int i,k = paths.size();
        String s;
        for(i=0;i<k;i++)
        {
            s = (String)paths.elementAt(i);
            if( s.startsWith(p) || p.startsWith(s) )
                 return false;
        }
        p = p.trim();
        if( !p.endsWith(File.separator) )
            p = p.concat(File.separator);
        paths.addElement(p);
        return true;
    }
    public static void clearUserPaths()
    {
        int i,k = paths.size();
        for(i=k-1;i>=pathCount;i--)
            paths.removeElementAt(i);
        return;
    }
    public static String getPreferredPath()
    {
        return (String)paths.elementAt(preferredPath);
    }
    public static boolean setPreferredPath(int p)
    {
        if(0 <= p && p < pathCount)
        {
            preferredPath = p;
            return true;
        }
        return false;
    }



    // IMPLEMENTACE XelfiFile
    private String      packagee;
    private String      name;
    private String      path;

    XFile()
    {
    }
    public XFile(String pPath,String pPackage,String className)
    {
        path = pPath;
        packagee = pPackage;
        name = className;
        return;
    }
    XFile(String pPath,String className)
    {
        path = pPath;
        int pom = className.lastIndexOf('.');
        if( pom < 0 )
        {
            packagee = "";
            name = className;
        }else
        {
            packagee = className.substring(0,pom);
            name = className.substring(pom + 1);
        }
        //System.out.println("CPS1 end" + path + " ; " +
          //  packagee + " ; " + name);
        return;
    }
    public boolean equals(XFile f)
    {
        if( f.path.equals(path) && f.packagee.equals(packagee) &&
            f.name.equals(name) )
            return true;
        return false;
    }
    /** Returns the whole path to the file.
    * @return the file of this source
    */
    public File getFile ()
    {
        return new File(getFileName());
    }
    public String getFileName ()
    {
        return path + packagee.replace('.',File.separatorChar) +
            (packagee.equals("") ? "" : File.separator) +
            (name.equals("") ? "" : (name + ".java"));
    }
    public String getFormName ()
    {
        return path + packagee.replace('.',File.separatorChar) +
            (packagee.equals("") ? "" : File.separator) +
            (name.equals("") ? "" : (name + ".form"));
    }
    public String getAllPath ()
    {
        return path + packagee.replace('.',File.separatorChar) +
            (packagee.equals("") ? "" : File.separator);
    }

    /** Returns the classpath. The part of path to the file that is
    * contained in the CLASSPATH.
    * @return the class path where the file is stored
    */
    public File getPath ()
    {
        return new File(path);
    }
    public String getPathStr ()
    {
        return path;
    }

    /** Returns the package of the file.
    * @return the package name
    */
    public String getPackage ()
    {
        return packagee;
    }

    /** Returns the name of the class.
    * @return only the name of class without the package prefix
    */
    public String getName ()
    {
        return name;
    }
}




