
package xelfi.browser.view;

import java.awt.*;
import java.io.*;
import xelfi.browser.document.*;
import xelfi.browser.util.*;

public class ProjectView extends xelfi.top.TopDialog implements modalObject
{
    Button buttonPrjFiles;
    //{{DECLARE_CONTROLS
    //}}
    Panel pp;

    Label label0;
    Label label2;
    List listProjectPaths;
    Label label3;
    List listSystemPaths;
    Label label4;
    TextField editPath;
    Button buttonDelPath;
    Button buttonAddPrj;
    Button buttonAddSys;


    TextField editHome;
    Label label1;
    TextField editName;
    Button buttonNew;
    Button buttonDel;
    Button buttonCopy;
    Button buttonPaste;
    Button buttonCut;
    Button buttonOpen;
    Button buttonReparse;
    Button buttonOpenPrj;
    Button buttonCancel;
    Button buttonOk;

    Dialog      d;
    BrProject   prj;
    boolean     pathsChanged = false;
    int         pomI = 0,pomK;

    public ProjectView(Frame f,BrProject p)
    {
        super(f,"Project view",true);
        prj = p;

        //{{INIT_CONTROLS
        //}}

        setLayout(new VertLayout(HorizLayout.CENTER,
            HorizLayout.TOP));

        addNotify();

        pp = new Panel();
        pp.setLayout(new HorizLayout(HorizLayout.RESIZE,
            HorizLayout.CENTER));

        label0=new Label("Project home:");
        pp.add(label0);

        label2=new Label("Project paths:");
        pp.add(label2);

        listProjectPaths=new List(3,false);
        //editPath.disable();
        int l = p.prjPackagePath.size(),i;
        for(i=0;i<l;i++)
            listProjectPaths.addItem((String)
                p.prjPackagePath.elementAt(i));
        pp.add(listProjectPaths);

        label3=new Label("System paths:");
        pp.add(label3);

        listSystemPaths=new List(3,false);
        //editPath.disable();
        l = p.sysPackagePath.size();
        for(i=0;i<l;i++)
            listSystemPaths.addItem((String)p.sysPackagePath.
                elementAt(i));
        pp.add(listSystemPaths);

        label4=new Label("Path:");
        pp.add(label4);

        editPath=new TextField("");
        //editName.disable();
        pp.add(editPath);

        buttonDelPath=new Button("Delete path");
        pp.add(buttonDelPath);

        buttonAddPrj=new Button("Add path to project");
        pp.add(buttonAddPrj);

        buttonAddSys=new Button("Add path to system");
        pp.add(buttonAddSys);

        add(pp);


        pp = new Panel();
        pp.setLayout(new HorizLayout(HorizLayout.RESIZE,
            HorizLayout.TOP));

        editHome=new TextField(p.path);
        //editName.disable();
        pp.add(editHome);

        if( p.isOpened() )
            label1=new Label("Opened project:");
        else
            label1=new Label("Project:");
        pp.add(label1);

        editName=new TextField(p.name);
        //editName.disable();
        pp.add(editName);

        buttonNew=new Button("New project");
        pp.add(buttonNew);

        buttonDel=new Button("Delete project");
        pp.add(buttonDel);

        Panel p1 = new Panel();
        p1.setLayout(new VertLayout());

        buttonCopy=new Button("Copy");
        p1.add(buttonCopy);

        buttonPaste = new Button("Paste");
        if( (BrowserSettings.Clipboard == null) ||
            !(BrowserSettings.Clipboard[0] instanceof BrProject) )
            buttonPaste.disable();
        p1.add(buttonPaste);

        buttonCut = new Button("Cut");
        p1.add(buttonCut);
        pp.add(p1);


        if( p.isOpened() )
            buttonOpenPrj = new Button("Close project");
        else
            buttonOpenPrj = new Button("Open project");
        pp.add(buttonOpenPrj);

        buttonOpen = new Button("Open in Browser");
        pp.add(buttonOpen);

        buttonReparse = new Button("Reparse all packages");
        pp.add(buttonReparse);

        buttonPrjFiles = new Button("Project files...");
        pp.add(buttonPrjFiles);

        buttonOk = new Button("Ok");
        pp.add(buttonOk);

        buttonCancel = new Button("Cancel");
        pp.add(buttonCancel);

        add(pp);

        pack();
        /*resize(insets().left + insets().right +
               preferredSize().width + 10, insets().top +
               insets().bottom + preferredSize().height + 10);*/

        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        show();
        resize(preferredSize());

    }

    public boolean handleEvent(Event e)
    {
        try{

       if (e.id == Event.WINDOW_DESTROY) {
           dispose();
           return true;
       }else
           if( e.id == Event.LIST_SELECT )
           {
            if( e.target == listProjectPaths )
            {
                listSystemPaths.deselect(listSystemPaths.
                    getSelectedIndex());
                editPath.setText(listProjectPaths.
                    getSelectedItem());
                return true;
            }else
            if( e.target == listSystemPaths )
            {
                listProjectPaths.deselect(listProjectPaths.
                    getSelectedIndex());
                editPath.setText(listSystemPaths.
                    getSelectedItem());
                return true;
            }
            return super.handleEvent(e);
        }else
        if( e.id == Event.ACTION_EVENT )
        {
            if( e.target == buttonDelPath)
            {
                if( listProjectPaths.getSelectedIndex() != -1 )
                {
                    listProjectPaths.delItem(listProjectPaths.
                        getSelectedIndex());
                    pathsChanged = true;
                }else
                if( listSystemPaths.getSelectedIndex() != -1 )
                {
                    listSystemPaths.delItem(listSystemPaths.
                        getSelectedIndex());
                    pathsChanged = true;
                }
                return true;
            }else
            if( e.target == buttonAddPrj)
            {
                String s = editPath.getText();
                if( s.length() > 0 )
                {
                    listProjectPaths.addItem(s);
                    pathsChanged = true;
                }
                return true;
            }else
            if( e.target == buttonAddSys)
            {
                String s = editPath.getText();
                if( s.length() > 0 )
                {
                    listSystemPaths.addItem(s);
                    pathsChanged = true;
                }
                return true;
            }else
            if( e.target == buttonNew )
            {
                BrProject p = new BrProject(prj.owner,
                    editName.getText(),editHome.getText());
                if( !prj.owner.addComponent(p) )
                {
                    d = new modalDialog(BrowserSettings.mainWindow,
                        this,2,"Project with this name",
                        "already exists!!!",null,modalDialog.OK);

                }else
                {
                    int i,k = listProjectPaths.countItems();
                    for(i=0;i<k;i++)
                        p.addPath(listProjectPaths.getItem(i),true);
                    k = listSystemPaths.countItems();
                    for(i=0;i<k;i++)
                        p.addPath(listSystemPaths.getItem(i),false);
                    //System.out.println("reparse...");
                    p.reparse();

                    dispose();
                    BrowserSettings.repaint(1);
                }
                return true;
            }else
            if( e.target == buttonDel )
            {
                dispose();
                d = new modalDialog(BrowserSettings.mainWindow,this,1,
                    "Do you really want to delete",
                    "this project?",null,modalDialog.YES_NO);
                return true;
            }else
            if( e.target == buttonCopy )
            {
                BrProject p = new BrProject(null,editName.getText(),
                        editHome.getText());
                BrowserSettings.Clipboard = new BrComponent[1];
                BrowserSettings.Clipboard[0] = p;

                if( pathsChanged )
                {
                    p.clearPaths();
                    int i,k = listProjectPaths.countItems();
                    for(i=0;i<k;i++)
                        p.addPath(listProjectPaths.
                            getItem(i),true);
                    k = listSystemPaths.countItems();
                    for(i=0;i<k;i++)
                        p.addPath(listSystemPaths.
                            getItem(i),false);
                    //System.out.println("reparse...");
                    p.reparse();

                }
                dispose();
                return true;
            }else
            if( e.target == buttonPaste )
            {
                dispose();
                if( BrowserSettings.Clipboard.length > 0 )
                {
                    if( BrowserSettings.Clipboard[0] instanceof
                        BrProject )
                    {
                        paste();
                    }else
                    {
                        d = new modalDialog(BrowserSettings.mainWindow,
                            this,3,"Objects in clipboard aren'n projects!",
                            "I cann't paste them.",null,modalDialog.OK);
                    }
                }
                return true;
            }else
            if( e.target == buttonCut )
            {
                BrowserSettings.Clipboard = new BrComponent[1];
                BrowserSettings.Clipboard[0] = prj;
                prj.name = editName.getText();
                if( pathsChanged )
                {
                    prj.clearPaths();
                    int i,k = listProjectPaths.countItems();
                    for(i=0;i<k;i++)
                        prj.addPath(listProjectPaths.getItem(i),true);
                    k = listSystemPaths.countItems();
                    for(i=0;i<k;i++)
                        prj.addPath(listSystemPaths.getItem(i),false);
                    //System.out.println("reparse...");
                    prj.reparse();

                }

                // DELETE PROJECT
                dispose();
                prj.owner.delProject(prj);
                BrowserSettings.repaint(1);
                return true;
            }else
            if( e.target == buttonOpen )
            {
                dispose();
                /*BrowserSettings.settings.Mode = 2;
                BrowserSettings.pomAssoc1 = new BrComponent[1];
                if( BrowserSettings.settings.Choice )
                {
                    BrowserSettings.pomAssoc1[0] = prj.owner;
                    BrowserSettings.pomAssoc2 = prj;
                }else
                    BrowserSettings.pomAssoc1[0] = prj;*/
               BrowserSettings.CreateBrowserWindow(false);
                return true;
            }else
            if( e.target == buttonReparse )
            {
                dispose();
                prj.reparse();

                BrowserSettings.repaint(2);
                return true;
            }else
            if( e.target == buttonOpenPrj )
            {
                //BrowserSettings.project.unmarkObjects();
                //save???
                ComponentManager.openProject(prj);
                dispose();
                return true;
            }else
            if( e.target == buttonOk )
            {
                if( (!prj.name.equals(editName.getText())) ||
                    (!prj.path.equals(editHome.getText())) )
                {
                    File f = new File(new File(editHome.getText()),
                        editName.getText() + ".prj");
                    if( f.exists() )
                    {
                        d = new modalDialog(BrowserSettings.mainWindow,
                            this,0,"Project file :",
                            "" + f,"already exists!!!",modalDialog.OK);
                        return true;
                    }
                    prj.name = editName.getText();
                    prj.path = editHome.getText();
                    prj.owner.changed = true;
                    prj.changed = true;
                }


                if( pathsChanged )
                {
                    prj.clearPaths();
                    int i,k = listProjectPaths.countItems();
                    for(i=0;i<k;i++)
                        prj.addPath(listProjectPaths.getItem(i),true);
                    k = listSystemPaths.countItems();
                    for(i=0;i<k;i++)
                        prj.addPath(listSystemPaths.getItem(i),false);
                    //System.out.println("reparse...");
                    prj.reparse();
                    prj.changed = true;
                }
                BrowserSettings.repaint(2);
                dispose();
                return true;
            }else
            if( e.target == buttonCancel )
            {
                dispose();
                return true;
            }
            return super.handleEvent(e);

        }
        return super.handleEvent(e);
        }catch(FileNotFoundException o)
        {//!!!
        }catch(IOException o)
        {}
        return true;
    }

    void paste()
    {
        if( pomI == 0 ) pomK = BrowserSettings.Clipboard.length;
        for(;pomI<pomK;pomI++)
        {
            if( !prj.owner.addComponent((BrProject)BrowserSettings.
                Clipboard[pomI]) )
            {
                d = new modalDialog(BrowserSettings.mainWindow,
                    this,4,"Project with this name",
                    "already exists!!!",null,modalDialog.OK);

            }else
                ((BrProject)BrowserSettings.Clipboard[pomI]).owner =
                    prj.owner;
        }
        BrowserSettings.repaint(1);
    }

    public void onOk(int index)
    {
        switch( index )
        {
        case 1:
            // DELETE PROJECT
            prj.owner.delProject(prj);
            BrowserSettings.repaint(1);
            break;
        case 4:
            paste();
            break;
        }
    }
    public void onNo(int index)
    {
    }
    public void onCancel(int index)
    {
    }


}


