/** ErrorColorerEvidence class
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.compiler;

import java.util.*;

  /** Methods of this class are all static. They provide access to ErrorColorer classes it is needed
    from different part of the program. */
public class ErrorColorerEvidence
{
  private static Hashtable tab = new Hashtable(20, 0.8f);

    /** Returns existing ErrorColorer or creates new one if doesn't exist.
      Increments its (internal) number of references. 
      @param className identifies an ErrorColorer
      @return reference to corresponding ErrorColorer instance
     */
  public static ErrorColorer getReference(String className)
  {
    ErrorColorer colr = (ErrorColorer)tab.get(className);
    if(colr == null) tab.put(className, colr = new ErrorColorer());
    colr.noReferences++;
    return colr;
  }

    /** Call when reference is no longer needed. When all references are closed, this class also closes
      its own reference so that the ErrorColorer class can be garbage collected.
      @param className which error colorer to close
    */
    // nejak prinutit aby se to volalo, kdyz se zavira reference z editoru
  public static void closeReference(String className)
  {
    ErrorColorer colr = (ErrorColorer)tab.get(className);
    if(colr != null && --colr.noReferences == 0) tab.remove(className);
  }
}
