/**
* Xelfi
*/

package xelfi.design.components.property;

import java.io.*;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Window;
import xelfi.design.components.XelfiDesignComponent;
import xelfi.design.components.dialogs.GridSetThread;
import xelfi.design.util.GridInfo;
import xelfi.util.Debug;

/**
 * @version 	1.03, 25 Feb 1997
 * @author 	Ian Formanek
 */

public class XGridPropertyType {
	/**
	 * This method invokes the specialInput Dialog.
	 * To perform this under JDK 1.02, a new thread must be started to do this.
	 * This method returns immediately allowing the AWT thread to run (if called from within
	 * the action method or so...).
	 * The new thread starts the dialog and then waits in a loop for some variable to be set.
	 * Then if user pressed the OK Button method setProperty of the component is called.
	 * @param	parent	parent of the dialog
	 * @param	xdc		Component which property to set
	 * @param	propNum	Index of the property to set
	 */
	public static void invokeSpecialInput(Frame parent, XelfiDesignComponent xdc, int propNum) {
		new GridSetThread("GridSetThread", parent, xdc, propNum).start(); 
	}

	public static String viewString(Object property) { 
		if (property instanceof GridInfo) {
			GridInfo gi = (GridInfo)property;
			if (gi.gridX() == 1 && gi.gridY() == 1) return "[no grid]";
			else return "["+gi.gridX()+", "+gi.gridY()+"]";
		}
		else return "[???]";
	}

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		GridInfo gi = (GridInfo)property;
		stream.writeInt(gi.gridX());
		stream.writeInt(gi.gridY());
		Debug.debug(Debug.PROPIO_SAVE, "XGridProperty saved");
	}

	public static GridInfo loadFromStream(DataInput stream) throws 
		IOException {
		int gx = stream.readInt();
		int gy = stream.readInt();
		Debug.debug(Debug.PROPIO_LOAD, "XGridProperty loaded: [x: "+gx+", y: "+gy);
		return new GridInfo(gx,gy);
	}
}
