/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.TrackBar;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XTrackBar extends XAWTPanel {
	private TrackBar tbar;

	private static int propertyCount = 18;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 9;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XTrackBar() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(tbar = new TrackBar());
		tbar.propagate = true;
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("trackbar.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.TrackBar";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		if (XFDesignOptions.designMode == XFDesignConstants.DM_REAL)
			tbar.propagate = false;
		else
			tbar.propagate = true;
		return super.handleEvent(evt);
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(tbar.getBackground());
			case 1: return ((Color) propDef[i]).equals(tbar.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == tbar.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 5: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 6: return (TrackBar.defaultValue == tbar.getValue());
			case 7: return (TrackBar.defaultMinimum == tbar.getMinimum());
			case 8: return (TrackBar.defaultMaximum == tbar.getMaximum());
			case 9: return (TrackBar.defaultPageStep == tbar.getPageStep());
			case 10: return (TrackBar.defaultLineStep == tbar.getLineStep());
			case 11: return (TrackBar.defaultLathWidth == tbar.getLathWidth());
			case 12: return (TrackBar.defaultBorderColor.equals(tbar.getBorderColor()));
			case 13: return (TrackBar.defaultFillColor.equals(tbar.getFillColor()));
			case 14: return (TrackBar.defaultOrientation == tbar.getOrientation());
			case 15: return (TrackBar.defaultTickMarks == tbar.getTickMarks());
			case 16: return (TrackBar.defaultTickLenght == tbar.getTickLenght());
			case 17: return (TrackBar.defaultFrequency == tbar.getFrequency());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (getBackground() != null)
				propDef[0] = new Color(tbar.getBackground().getRGB());
		if (getForeground() != null)
				propDef[1] = new Color(tbar.getForeground().getRGB());
		propDef[2] = new Boolean(tbar.isEnabled());
		propDef[3] = new Boolean(bVisible);
		propDef[4] = new Boolean(autoSize);
		propDef[5] = new Boolean(parentColor);
		propDef[6] = new Integer(-1);
		propDef[7] = new Integer(-1);
		propDef[8] = new Integer(-1);
		propDef[9] = new Integer(-1);
		propDef[10] = new Integer(-1);
		propDef[11] = new Integer(-1);
		propDef[12] = new Integer(-1);
		propDef[13] = new Integer(-1);
		propDef[14] = new Integer(-1);
		propDef[15] = new Integer(-1);
		propDef[16] = new Integer(-1);
		propDef[17] = new Integer(-1);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return tbar.getBackground();
			case 1: return tbar.getForeground();
			case 2: return (tbar.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 5: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return new Integer(tbar.getValue());
			case 7: return new Integer(tbar.getMinimum());
			case 8: return new Integer(tbar.getMaximum());
			case 9: return new Integer(tbar.getPageStep());
			case 10: return new Integer(tbar.getLineStep());
			case 11: return new Integer(tbar.getLathWidth());
			case 12: return tbar.getBorderColor();
			case 13: return tbar.getFillColor();
			case 14: return (tbar.getOrientation()) ? Boolean.TRUE : Boolean.FALSE;
			case 15: return new Integer(tbar.getTickMarks());
			case 16: return new Integer(tbar.getTickLenght());
			case 17: return new Integer(tbar.getFrequency());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = new String("Background Color"); 
		list[1] = new String("Foreground Color"); 
		list[2] = new String("Enabled"); 
		list[3] = new String("Visible"); 
		list[4] = new String("Auto Size"); 
		list[5] = new String("Parent Color"); 
		list[6] = new String("Value");
		list[7] = new String("Minimum");
		list[8] = new String("Maximum");
		list[9] = new String("Page Step");
		list[10] = new String("Line Step");
		list[11] = new String("Lath width");
		list[12] = new String("Border Color");
		list[13] = new String("Fill Color");
		list[14] = new String("Orientation");
		list[15] = new String("Tick Marks");
		list[16] = new String("Tick Lenght");
		list[17] = new String("Frequency");
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3:
			case 4: 
			case 5: return XBooleanPropertyType.viewString(getProperty(index));
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11: return XIntegerPropertyType.viewString(getProperty(index));
			case 12:
			case 13: return XColorPropertyType.viewString(getProperty(index));
			case 14: return XBooleanPropertyType.viewString(getProperty(index));
			case 15:
			case 16:
			case 17: return XIntegerPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3:
			case 4: 
			case 5: return XFDesignConstants.PVT_CHECK;
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11: return XFDesignConstants.PVT_INPUT_INT;
			case 12:
			case 13: return XFDesignConstants.PVT_SPECIAL;
			case 14:
			case 15: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 16:
			case 17: return XFDesignConstants.PVT_INPUT_INT;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 14: String[] ret = new String[2];
					ret[0] = "HORIZONTAL";
					ret[1] = "VERTICAL";
					return ret;
			case 15: String[] ret1 = new String[4];
					ret1[0] = "BOTTOM-RIGHT";
					ret1[1] = "TOP-LEFT";
					ret1[2] = "BOTH";
					ret1[3] = "NONE";
					return ret1;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 14: Boolean[] ret = new Boolean[2];
					ret[0] = new Boolean(TrackBar.DIR_HORIZONTAL);
					ret[1] = new Boolean(TrackBar.DIR_VERTICAL);
					return ret;
			case 15: Integer[] ret1 = new Integer[4];
					ret1[0] = new Integer(TrackBar.TM_BOTTOMRIGHT);
					ret1[1] = new Integer(TrackBar.TM_TOPLEFT);
					ret1[2] = new Integer(TrackBar.TM_BOTH);
					ret1[3] = new Integer(TrackBar.TM_NONE);
					return ret1;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tbar.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					tbar.repaint();
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tbar.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					tbar.repaint();
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					tbar.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setValue(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 7: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setMinimum(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 8: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setMaximum(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 9: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setPageStep(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 10: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setLineStep(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 11:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setLathWidth(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 12:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tbar.setBorderColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 13:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tbar.setFillColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 14:if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					tbar.setOrientation(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 15:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setTickMarks(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 16:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setTickLenght(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			case 17:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tbar.setFrequency(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tbar.repaint();
					}
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1:
			case 12:
			case 13:XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		list[2] = "OnLineUp";
		list[3] = "OnLineDown";
		list[4] = "OnPageUp";
		list[5] = "OnPageDown";
		list[6] = "OnHome";
		list[7] = "OnEnd";
		list[8] = "OnDrag";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "TrackBar";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(tbar.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(tbar.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (tbar.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 6: gen = gen + name + ".setValue(" + tbar.getValue() + ");\n";
									break;
							case 7: gen = gen + name + ".setMinimum(" + tbar.getMinimum() + ");\n";
									break;
							case 8: gen = gen + name + ".setMaximum(" + tbar.getMaximum() + ");\n";
									break;
							case 9: gen = gen + name + ".setPageStep(" + tbar.getPageStep() + ");\n";
									break;
							case 10: gen = gen + name + ".setLineStep(" + tbar.getLineStep() + ");\n";
									break;
							case 11: gen = gen + name + ".setLathWidth(" + tbar.getLathWidth() + ");\n";
									break;
							case 12: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(tbar.getBorderColor()) + ");\n";
									break;
							case 13: gen = gen + name + ".setFillColor(" +
										XFDesignUtils.genColor(tbar.getFillColor()) + ");\n";
									break;
							case 14: gen = gen + name + ".setOrientation(TrackBar.DIR_";
									if (tbar.getOrientation() == TrackBar.DIR_HORIZONTAL)
										gen = gen + "HORIZONTAL";
									else
										gen = gen + "VERTICAL";
									gen = gen + ");\n";
									break;
							case 15: gen = gen + name + ".setTickMarks(TrackBar.TM_";
									switch (tbar.getTickMarks()) {
										case TrackBar.TM_BOTTOMRIGHT: gen = gen + "BOTTOMRIGHT";break;
										case TrackBar.TM_TOPLEFT: gen = gen + "TOPLEFT";break;
										case TrackBar.TM_BOTH: gen = gen + "BOTH";break;
										case TrackBar.TM_NONE: gen = gen + "NONE";break;
									}
									gen = gen + ");\n";
									break;
							case 16: gen = gen + name + ".setTickLenght(" + tbar.getTickLenght() + ");\n";
									break;
							case 17: gen = gen + name + ".setFrequency(" + tbar.getFrequency() + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == TrackBar.TB_LINEUP && "+evt+".target == "+getName();
			case 3: return evt +".id == TrackBar.TB_LINEDOWN && "+evt+".target == "+getName();
			case 4: return evt +".id == TrackBar.TB_PAGEUP && "+evt+".target == "+getName();
			case 5: return evt +".id == TrackBar.TB_PAGEDOWN && "+evt+".target == "+getName();
			case 6: return evt +".id == TrackBar.TB_HOME && "+evt+".target == "+getName();
			case 7: return evt +".id == TrackBar.TB_END && "+evt+".target == "+getName();
			case 8: return evt +".id == TrackBar.TB_DRAG && "+evt+".target == "+getName();

			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: tbar.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: tbar.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: tbar.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 5: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: tbar.setValue(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 7: tbar.setMinimum(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 8: tbar.setMaximum(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 9: tbar.setPageStep(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 10: tbar.setLineStep(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 11: tbar.setLathWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 12: tbar.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 13: tbar.setFillColor(XColorPropertyType.loadFromStream(stream)); break;
				case 14: tbar.setOrientation(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 15: tbar.setTickMarks(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 16: tbar.setTickLenght(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 17: tbar.setFrequency(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(tbar.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(tbar.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(tbar.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 5: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 6: XIntegerPropertyType.saveToStream(new Integer(tbar.getValue()), stream); break;
					case 7: XIntegerPropertyType.saveToStream(new Integer(tbar.getMinimum()), stream); break;
					case 8: XIntegerPropertyType.saveToStream(new Integer(tbar.getMaximum()), stream); break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(tbar.getPageStep()), stream); break;
					case 10: XIntegerPropertyType.saveToStream(new Integer(tbar.getLineStep()), stream); break;
					case 11: XIntegerPropertyType.saveToStream(new Integer(tbar.getLathWidth()), stream); break;
					case 12: XColorPropertyType.saveToStream(tbar.getBorderColor(), stream); break;
					case 13: XColorPropertyType.saveToStream(tbar.getFillColor(), stream); break;
					case 14: XBooleanPropertyType.saveToStream(tbar.getOrientation(), stream); break;
					case 15: XIntegerPropertyType.saveToStream(new Integer(tbar.getTickMarks()), stream); break;
					case 16: XIntegerPropertyType.saveToStream(new Integer(tbar.getTickLenght()), stream); break;
					case 17: XIntegerPropertyType.saveToStream(new Integer(tbar.getFrequency()), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}