/**
* Xelfi
*/

package xelfi.design.forms;

import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.util.Debug;

/* 
 * Class XFFormInheritance 
 *
 * @version 	1.04, 31 Mar 1997
 * @author 	Ian Formanek
 */

class XFFormInheritance {
	boolean isPublic = true;
	String pImplements[] = new String[0];
	String extendsWhat;
	String constructorParams;
	String superCall;
	
	public XFFormInheritance(String aExtendsWhat, String aConstructorParams, String aSuperCall) {
		extendsWhat = aExtendsWhat;
		constructorParams = aConstructorParams;
		superCall = aSuperCall;
	}
	
	public void setDialogModal(boolean modal) {
		superCall = modal?"super(parent, true);":"super(parent, false);";
	}
	
	public static XFFormInheritance Frame() {
		return new XFFormInheritance("Frame", "", "super();");
	}
	
	public static XFFormInheritance Dialog(boolean isModal) {
		return isModal ? 
			new XFFormInheritance("Dialog", "Frame parent","super(parent, true);") :
			new XFFormInheritance("Dialog", "Frame parent","super(parent, false);");
	}
	
	public static XFFormInheritance Applet() {
		return new XFFormInheritance("java.applet.Applet", "", "");
	}
	
	public String generateClassBegin(String formName) {
		String gen;
		if (pImplements.length>0) {
			String impl = pImplements[0];
			for (int i=1; i<pImplements.length; i++)
				impl = impl+ ", "+pImplements[i];
			gen = (isPublic)? "public class "+ formName + " extends "+extendsWhat+"\n"+
			                  XFDesignOptions.indent(1)+"implements "+impl+" {\n":
			                        "class "+ formName + " extends "+extendsWhat+"\n"+
				            XFDesignOptions.indent(1)+"implements "+impl+" {\n";
		}
		else
			gen = (isPublic)? "public class "+ formName + " extends "+extendsWhat+" {\n":
			                        "class "+ formName + " extends "+extendsWhat+" {\n";
		return gen;
	}

	public String generateConstructorBegin(String formName) {
		String gen = XFDesignOptions.indent(1)+
			"public "+ formName + "("+constructorParams+") {\n";
		if (superCall != null && !("".equals(superCall)))
			gen = gen + XFDesignOptions.indent(2)+ superCall + "\n";
		return gen;
	}

}