/**
* Xelfi Environment
*/

package xelfi.editor;

/** Informs about changes in the text editor.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public interface EditorListener {
  /** Called when action requested by user in editor is not allowed.
  * @param info info about document
  * @param ins true if insert, false if delete
  */
  public void editorNotAllowedAction (TextEditorInfo info);

  /** When user double clicks with mouse this will be called.
  * @param info editor info
  * @param p position of click
  */
  public void editorDoubleClick (TextEditorInfo info, Position p);

  /** Notifies change of view (visible part of document)
  * @param info editor info
  */
  public void editorViewChanged (TextEditorInfo info);
}





// Generated from substitution template 'XelfiInterface'