/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.awt.Font;
import java.awt.Color;

/**
* Extends the StartDrawInfo to contain info
* by fields for default background settings and
* settings for syntax coloring.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class StandardDrawInfo extends StartDrawInfo {
  /** the default background color */
  Color defaultBack;

  /** the default foreground color, if specified by BackgroundCallback */
  Color defaultText;

  /** the info about syntax coloring */
  TextDrawInfo syntax;

  /** the previous position */
  Position prev;

  /** Initialize the draw info.
  * @param p the position to set to the end field
  */
  public StandardDrawInfo (Position p) {
    end = p;
    first = p;
  };
};


