/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.io.File;
/**
*
* @version 1.0
* @author Jaroslav Tulach
*/

class StandardXelfiFile extends XelfiFile {
  /** part of the class path */
  File path;

  /** package */
  String pack;

  /** name of class */
  String name;
  
  /** Returns the whole path to the file.
  * @return the file of this source
  */
  public File getFile () {
    String p = path.toString ();

    return p.charAt ((int)(p.length () - 1)) == '/' ?
      new File (p + name + ".java")
      :
      new File (p,  name + ".java");
  };
  
  /** Returns the classpath. The part of path to the file that is
  * contained in the CLASSPATH.
  * @return the class path where the file is stored
  */
  public File getPath () {
    return path;
  };
  
  /** Returns the package of the file.
  * @return the package name
  */
  public String getPackage () {
    return pack;
  };
  
  /** Returns the name of the class.
  * @return only the name of class without the package prefix
  */
  public String getName () {
    return name;
  };
};








