/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.awt.Font;
import java.awt.Color;

/**
* Extends the TextDrawInfo by two fields.
* This info is returned from the methods that
* are called at the begin of drawing.
*
* @see EditorCallback#beginInsert
* @see EditorCallback#beginDelete
* @see EditorCallback#beginDraw
*
* @version 1.0
* @author Jaroslav Tulach
*/

public class StartDrawInfo extends TextDrawInfo {
  /** The position where the redraw should start */
  public Position first;

  /** The last position. Here the redraw will terminate.
  * Rest of text will not be affected.
  */
  public Position last;
};


