/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
*
* @version 1.0
* @author Jaroslav Tulach
*/

class WordSearch extends Object implements Acceptor {
  /** true, if there already was a space */
  boolean occured = false;

  /** something accepted */
  boolean once = false;

  /**
  * should we continue or stop the action?
  * @param ch the character at specified position
  * @return true/false
  */
  public boolean accept (char ch) {
    if (ch == '\n' && once) return true;
    once = true;
    if (!isSpace (ch)) {
      if (occured) return true;
    } else {
      occured = true;
    };
    return false;
  };

  /** Tests if a char is a space
  * @param ch the char
  */
  static boolean isSpace (char ch) {
    return !Character.isLetterOrDigit (ch);
  };
  
};


