package xelfi.execution;

import java.awt.*;
import java.io.IOException;

public class OutputTextArea extends TextArea implements FormatedOutput
{
  public static final int CLOSED = 1;
  private int clearAfter;             // when this number of lines is riched text is cleared
  private int lines;                  // current # of lines

  public OutputTextArea(int lines, int cols)
  {
    this(lines, cols, 100);
  }

  public OutputTextArea(int cclearAfter)
  {
    this(8, 40, cclearAfter);
  }

  public OutputTextArea()
  {
    this(8, 40, 100);
  }

  public OutputTextArea(int cols, int lines, int cclearAfter)
  {
    super(cols, lines);
    clearAfter = cclearAfter;
    lines = 0;
    setEditable(false);
  }

  public synchronized void printline(String line)
  {
    if(lines++ == clearAfter)
    {
      setText("");
      lines = 1;
    }

    appendText(line);
    appendText("\n");
  }

  public synchronized void printtext(String txt)
  {
    appendText(txt);
  }

  public void close()
  {
    Event closeEv = new Event(this, Event.ACTION_EVENT, null);
    closeEv.key = CLOSED;
    getParent().postEvent(closeEv);
  }
}









